# coding: utf-8

"""
    Wandelbots Nova Public API

    Interact with robots in an easy and intuitive way. 

    The version of the OpenAPI document: 1.0.0 beta
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictFloat, StrictInt, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Union
from typing import Optional, Set
from typing_extensions import Self

class Box3(BaseModel):
    """
    Centered around origin.  If margin is applied to full box, it is added to all sizes (shape still has edges). Hollow box is represented by thin boxes that make up its walls. If margin is applied to hollow box, its sizes are reduced by the margin. 
    """ # noqa: E501
    shape_type: StrictStr
    size_x: Union[StrictFloat, StrictInt]
    size_y: Union[StrictFloat, StrictInt]
    size_z: Union[StrictFloat, StrictInt]
    type: StrictStr
    __properties: ClassVar[List[str]] = ["shape_type", "size_x", "size_y", "size_z", "type"]

    @field_validator('shape_type')
    def shape_type_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['box']):
            raise ValueError("must be one of enum values ('box')")
        return value

    @field_validator('type')
    def type_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['HOLLOW', 'FULL']):
            raise ValueError("must be one of enum values ('HOLLOW', 'FULL')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Box3 from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Box3 from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "shape_type": obj.get("shape_type") if obj.get("shape_type") is not None else 'box',
            "size_x": obj.get("size_x"),
            "size_y": obj.get("size_y"),
            "size_z": obj.get("size_z"),
            "type": obj.get("type") if obj.get("type") is not None else 'FULL'
        })
        return _obj


