# coding: utf-8

"""
    Wandelbots Nova Public API

    Interact with robots in an easy and intuitive way. 

    The version of the OpenAPI document: 2.0.0 beta
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
import pprint
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Any, List, Optional
from wandelbots_api_client.v2.models.blending_auto import BlendingAuto
from wandelbots_api_client.v2.models.blending_position import BlendingPosition
from pydantic import StrictStr, Field
from typing import Union, List, Set, Optional, Dict
from typing_extensions import Literal, Self

MOTIONCOMMANDBLENDING_ONE_OF_SCHEMAS = ["BlendingAuto", "BlendingPosition"]

class MotionCommandBlending(BaseModel):
    """
    Blending alters the TCP path at the target point of a motion command to ensure that the velocity does not drop to zero between two motion commands. 
    """
    # data type: BlendingAuto
    oneof_schema_1_validator: Optional[BlendingAuto] = None
    # data type: BlendingPosition
    oneof_schema_2_validator: Optional[BlendingPosition] = None
    actual_instance: Optional[Union[BlendingAuto, BlendingPosition]] = None
    one_of_schemas: Set[str] = { "BlendingAuto", "BlendingPosition" }

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )


    discriminator_value_class_map: Dict[str, str] = {
    }

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = MotionCommandBlending.model_construct()
        error_messages = []
        match = 0
        # validate data type: BlendingAuto
        if not isinstance(v, BlendingAuto):
            error_messages.append(f"Error! Input type `{type(v)}` is not `BlendingAuto`")
        else:
            match += 1
        # validate data type: BlendingPosition
        if not isinstance(v, BlendingPosition):
            error_messages.append(f"Error! Input type `{type(v)}` is not `BlendingPosition`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in MotionCommandBlending with oneOf schemas: BlendingAuto, BlendingPosition. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in MotionCommandBlending with oneOf schemas: BlendingAuto, BlendingPosition. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # use oneOf discriminator to lookup the data type
        _data_type = json.loads(json_str).get("blending_name")
        if not _data_type:
            raise ValueError("Failed to lookup data type from the field `blending_name` in the input.")

        # check if data type is `BlendingAuto`
        if _data_type == "BlendingAuto":
            instance.actual_instance = BlendingAuto.from_json(json_str)
            return instance

        # check if data type is `BlendingPosition`
        if _data_type == "BlendingPosition":
            instance.actual_instance = BlendingPosition.from_json(json_str)
            return instance

        # deserialize data into BlendingAuto
        try:
            instance.actual_instance = BlendingAuto.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into BlendingPosition
        try:
            instance.actual_instance = BlendingPosition.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into MotionCommandBlending with oneOf schemas: BlendingAuto, BlendingPosition. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into MotionCommandBlending with oneOf schemas: BlendingAuto, BlendingPosition. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], BlendingAuto, BlendingPosition]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())


